git-am.shon commit Merge branch 'js/log-show-children' (aadf863)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5SUBDIRECTORY_OK=Yes
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_SPEC="\
   8git am [options] [(<mbox>|<Maildir>)...]
   9git am [options] (--resolved | --skip | --abort)
  10--
  11i,interactive   run interactively
  12b,binary*       (historical option -- no-op)
  133,3way          allow fall back on 3way merging if needed
  14q,quiet         be quiet
  15s,signoff       add a Signed-off-by line to the commit message
  16u,utf8          recode into utf8 (default)
  17k,keep          pass -k flag to git-mailinfo
  18keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
  19no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
  20c,scissors      strip everything before a scissors line
  21whitespace=     pass it through git-apply
  22ignore-space-change pass it through git-apply
  23ignore-whitespace pass it through git-apply
  24directory=      pass it through git-apply
  25exclude=        pass it through git-apply
  26C=              pass it through git-apply
  27p=              pass it through git-apply
  28patch-format=   format the patch(es) are in
  29reject          pass it through git-apply
  30resolvemsg=     override error message when patch failure occurs
  31continue        continue applying patches after resolving a conflict
  32r,resolved      synonyms for --continue
  33skip            skip the current patch
  34abort           restore the original branch and abort the patching operation.
  35committer-date-is-author-date    lie about committer date
  36ignore-date     use current timestamp for author date
  37rerere-autoupdate update the index with reused conflict resolution if possible
  38rebasing*       (internal use for git-rebase)"
  39
  40. git-sh-setup
  41. git-sh-i18n
  42prefix=$(git rev-parse --show-prefix)
  43set_reflog_action am
  44require_work_tree
  45cd_to_toplevel
  46
  47git var GIT_COMMITTER_IDENT >/dev/null ||
  48        die "$(gettext "You need to set your committer info first")"
  49
  50if git rev-parse --verify -q HEAD >/dev/null
  51then
  52        HAS_HEAD=yes
  53else
  54        HAS_HEAD=
  55fi
  56
  57cmdline="git am"
  58if test '' != "$interactive"
  59then
  60        cmdline="$cmdline -i"
  61fi
  62if test '' != "$threeway"
  63then
  64        cmdline="$cmdline -3"
  65fi
  66
  67sq () {
  68        git rev-parse --sq-quote "$@"
  69}
  70
  71stop_here () {
  72    echo "$1" >"$dotest/next"
  73    git rev-parse --verify -q HEAD >"$dotest/abort-safety"
  74    exit 1
  75}
  76
  77safe_to_abort () {
  78        if test -f "$dotest/dirtyindex"
  79        then
  80                return 1
  81        fi
  82
  83        if ! test -s "$dotest/abort-safety"
  84        then
  85                return 0
  86        fi
  87
  88        abort_safety=$(cat "$dotest/abort-safety")
  89        if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
  90        then
  91                return 0
  92        fi
  93                gettextln "You seem to have moved HEAD since the last 'am' failure.
  94Not rewinding to ORIG_HEAD" >&2
  95        return 1
  96}
  97
  98stop_here_user_resolve () {
  99    if [ -n "$resolvemsg" ]; then
 100            printf '%s\n' "$resolvemsg"
 101            stop_here $1
 102    fi
 103    eval_gettextln "When you have resolved this problem run \"\$cmdline --resolved\".
 104If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 105To restore the original branch and stop patching run \"\$cmdline --abort\"."
 106
 107    stop_here $1
 108}
 109
 110go_next () {
 111        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
 112                "$dotest/patch" "$dotest/info"
 113        echo "$next" >"$dotest/next"
 114        this=$next
 115}
 116
 117cannot_fallback () {
 118        echo "$1"
 119        gettextln "Cannot fall back to three-way merge."
 120        exit 1
 121}
 122
 123fall_back_3way () {
 124    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
 125
 126    rm -fr "$dotest"/patch-merge-*
 127    mkdir "$dotest/patch-merge-tmp-dir"
 128
 129    # First see if the patch records the index info that we can use.
 130    git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
 131        "$dotest/patch" &&
 132    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 133    git write-tree >"$dotest/patch-merge-base+" ||
 134    cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
 135
 136    say Using index info to reconstruct a base tree...
 137    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 138        git apply --cached <"$dotest/patch"
 139    then
 140        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
 141        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
 142    else
 143        cannot_fallback "$(gettext "Did you hand edit your patch?
 144It does not apply to blobs recorded in its index.")"
 145    fi
 146
 147    test -f "$dotest/patch-merge-index" &&
 148    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
 149    orig_tree=$(cat "$dotest/patch-merge-base") &&
 150    rm -fr "$dotest"/patch-merge-* || exit 1
 151
 152    say "$(gettext "Falling back to patching base and 3-way merge...")"
 153
 154    # This is not so wrong.  Depending on which base we picked,
 155    # orig_tree may be wildly different from ours, but his_tree
 156    # has the same set of wildly different changes in parts the
 157    # patch did not touch, so recursive ends up canceling them,
 158    # saying that we reverted all those changes.
 159
 160    eval GITHEAD_$his_tree='"$FIRSTLINE"'
 161    export GITHEAD_$his_tree
 162    if test -n "$GIT_QUIET"
 163    then
 164            GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 165    fi
 166    git-merge-recursive $orig_tree -- HEAD $his_tree || {
 167            git rerere $allow_rerere_autoupdate
 168            echo Failed to merge in the changes.
 169            exit 1
 170    }
 171    unset GITHEAD_$his_tree
 172}
 173
 174clean_abort () {
 175        test $# = 0 || echo >&2 "$@"
 176        rm -fr "$dotest"
 177        exit 1
 178}
 179
 180patch_format=
 181
 182check_patch_format () {
 183        # early return if patch_format was set from the command line
 184        if test -n "$patch_format"
 185        then
 186                return 0
 187        fi
 188
 189        # we default to mbox format if input is from stdin and for
 190        # directories
 191        if test $# = 0 || test "x$1" = "x-" || test -d "$1"
 192        then
 193                patch_format=mbox
 194                return 0
 195        fi
 196
 197        # otherwise, check the first few non-blank lines of the first
 198        # patch to try to detect its format
 199        {
 200                # Start from first line containing non-whitespace
 201                l1=
 202                while test -z "$l1"
 203                do
 204                        read l1
 205                done
 206                read l2
 207                read l3
 208                case "$l1" in
 209                "From "* | "From: "*)
 210                        patch_format=mbox
 211                        ;;
 212                '# This series applies on GIT commit'*)
 213                        patch_format=stgit-series
 214                        ;;
 215                "# HG changeset patch")
 216                        patch_format=hg
 217                        ;;
 218                *)
 219                        # if the second line is empty and the third is
 220                        # a From, Author or Date entry, this is very
 221                        # likely an StGIT patch
 222                        case "$l2,$l3" in
 223                        ,"From: "* | ,"Author: "* | ,"Date: "*)
 224                                patch_format=stgit
 225                                ;;
 226                        *)
 227                                ;;
 228                        esac
 229                        ;;
 230                esac
 231                if test -z "$patch_format" &&
 232                        test -n "$l1" &&
 233                        test -n "$l2" &&
 234                        test -n "$l3"
 235                then
 236                        # This begins with three non-empty lines.  Is this a
 237                        # piece of e-mail a-la RFC2822?  Grab all the headers,
 238                        # discarding the indented remainder of folded lines,
 239                        # and see if it looks like that they all begin with the
 240                        # header field names...
 241                        tr -d '\015' <"$1" |
 242                        sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
 243                        sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
 244                        patch_format=mbox
 245                fi
 246        } < "$1" || clean_abort
 247}
 248
 249split_patches () {
 250        case "$patch_format" in
 251        mbox)
 252                if test -n "$rebasing" || test t = "$keepcr"
 253                then
 254                    keep_cr=--keep-cr
 255                else
 256                    keep_cr=
 257                fi
 258                git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
 259                clean_abort
 260                ;;
 261        stgit-series)
 262                if test $# -ne 1
 263                then
 264                        clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
 265                fi
 266                series_dir=`dirname "$1"`
 267                series_file="$1"
 268                shift
 269                {
 270                        set x
 271                        while read filename
 272                        do
 273                                set "$@" "$series_dir/$filename"
 274                        done
 275                        # remove the safety x
 276                        shift
 277                        # remove the arg coming from the first-line comment
 278                        shift
 279                } < "$series_file" || clean_abort
 280                # set the patch format appropriately
 281                patch_format=stgit
 282                # now handle the actual StGIT patches
 283                split_patches "$@"
 284                ;;
 285        stgit)
 286                this=0
 287                for stgit in "$@"
 288                do
 289                        this=`expr "$this" + 1`
 290                        msgnum=`printf "%0${prec}d" $this`
 291                        # Perl version of StGIT parse_patch. The first nonemptyline
 292                        # not starting with Author, From or Date is the
 293                        # subject, and the body starts with the next nonempty
 294                        # line not starting with Author, From or Date
 295                        perl -ne 'BEGIN { $subject = 0 }
 296                                if ($subject > 1) { print ; }
 297                                elsif (/^\s+$/) { next ; }
 298                                elsif (/^Author:/) { s/Author/From/ ; print ;}
 299                                elsif (/^(From|Date)/) { print ; }
 300                                elsif ($subject) {
 301                                        $subject = 2 ;
 302                                        print "\n" ;
 303                                        print ;
 304                                } else {
 305                                        print "Subject: ", $_ ;
 306                                        $subject = 1;
 307                                }
 308                        ' < "$stgit" > "$dotest/$msgnum" || clean_abort
 309                done
 310                echo "$this" > "$dotest/last"
 311                this=
 312                msgnum=
 313                ;;
 314        hg)
 315                this=0
 316                for hg in "$@"
 317                do
 318                        this=$(( $this + 1 ))
 319                        msgnum=$(printf "%0${prec}d" $this)
 320                        # hg stores changeset metadata in #-commented lines preceding
 321                        # the commit message and diff(s). The only metadata we care about
 322                        # are the User and Date (Node ID and Parent are hashes which are
 323                        # only relevant to the hg repository and thus not useful to us)
 324                        # Since we cannot guarantee that the commit message is in
 325                        # git-friendly format, we put no Subject: line and just consume
 326                        # all of the message as the body
 327                        perl -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
 328                                if ($subject) { print ; }
 329                                elsif (/^\# User /) { s/\# User/From:/ ; print ; }
 330                                elsif (/^\# Date /) {
 331                                        my ($hashsign, $str, $time, $tz) = split ;
 332                                        $tz = sprintf "%+05d", (0-$tz)/36;
 333                                        print "Date: " .
 334                                              strftime("%a, %d %b %Y %H:%M:%S ",
 335                                                       localtime($time))
 336                                              . "$tz\n";
 337                                } elsif (/^\# /) { next ; }
 338                                else {
 339                                        print "\n", $_ ;
 340                                        $subject = 1;
 341                                }
 342                        ' <"$hg" >"$dotest/$msgnum" || clean_abort
 343                done
 344                echo "$this" >"$dotest/last"
 345                this=
 346                msgnum=
 347                ;;
 348        *)
 349                if test -n "$patch_format"
 350                then
 351                        clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
 352                else
 353                        clean_abort "$(gettext "Patch format detection failed.")"
 354                fi
 355                ;;
 356        esac
 357}
 358
 359prec=4
 360dotest="$GIT_DIR/rebase-apply"
 361sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
 362resolvemsg= resume= scissors= no_inbody_headers=
 363git_apply_opt=
 364committer_date_is_author_date=
 365ignore_date=
 366allow_rerere_autoupdate=
 367
 368if test "$(git config --bool --get am.keepcr)" = true
 369then
 370    keepcr=t
 371fi
 372
 373while test $# != 0
 374do
 375        case "$1" in
 376        -i|--interactive)
 377                interactive=t ;;
 378        -b|--binary)
 379                : ;;
 380        -3|--3way)
 381                threeway=t ;;
 382        -s|--signoff)
 383                sign=t ;;
 384        -u|--utf8)
 385                utf8=t ;; # this is now default
 386        --no-utf8)
 387                utf8= ;;
 388        -k|--keep)
 389                keep=t ;;
 390        -c|--scissors)
 391                scissors=t ;;
 392        --no-scissors)
 393                scissors=f ;;
 394        -r|--resolved|--continue)
 395                resolved=t ;;
 396        --skip)
 397                skip=t ;;
 398        --abort)
 399                abort=t ;;
 400        --rebasing)
 401                rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
 402        -d|--dotest)
 403                die "$(gettext "-d option is no longer supported.  Do not use.")"
 404                ;;
 405        --resolvemsg)
 406                shift; resolvemsg=$1 ;;
 407        --whitespace|--directory|--exclude)
 408                git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
 409        -C|-p)
 410                git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
 411        --patch-format)
 412                shift ; patch_format="$1" ;;
 413        --reject|--ignore-whitespace|--ignore-space-change)
 414                git_apply_opt="$git_apply_opt $1" ;;
 415        --committer-date-is-author-date)
 416                committer_date_is_author_date=t ;;
 417        --ignore-date)
 418                ignore_date=t ;;
 419        --rerere-autoupdate|--no-rerere-autoupdate)
 420                allow_rerere_autoupdate="$1" ;;
 421        -q|--quiet)
 422                GIT_QUIET=t ;;
 423        --keep-cr)
 424                keepcr=t ;;
 425        --no-keep-cr)
 426                keepcr=f ;;
 427        --)
 428                shift; break ;;
 429        *)
 430                usage ;;
 431        esac
 432        shift
 433done
 434
 435# If the dotest directory exists, but we have finished applying all the
 436# patches in them, clear it out.
 437if test -d "$dotest" &&
 438   last=$(cat "$dotest/last") &&
 439   next=$(cat "$dotest/next") &&
 440   test $# != 0 &&
 441   test "$next" -gt "$last"
 442then
 443   rm -fr "$dotest"
 444fi
 445
 446if test -d "$dotest"
 447then
 448        case "$#,$skip$resolved$abort" in
 449        0,*t*)
 450                # Explicit resume command and we do not have file, so
 451                # we are happy.
 452                : ;;
 453        0,)
 454                # No file input but without resume parameters; catch
 455                # user error to feed us a patch from standard input
 456                # when there is already $dotest.  This is somewhat
 457                # unreliable -- stdin could be /dev/null for example
 458                # and the caller did not intend to feed us a patch but
 459                # wanted to continue unattended.
 460                test -t 0
 461                ;;
 462        *)
 463                false
 464                ;;
 465        esac ||
 466        die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
 467        resume=yes
 468
 469        case "$skip,$abort" in
 470        t,t)
 471                die "$(gettext "Please make up your mind. --skip or --abort?")"
 472                ;;
 473        t,)
 474                git rerere clear
 475                git read-tree --reset -u HEAD HEAD
 476                orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
 477                git reset HEAD
 478                git update-ref ORIG_HEAD $orig_head
 479                ;;
 480        ,t)
 481                if test -f "$dotest/rebasing"
 482                then
 483                        exec git rebase --abort
 484                fi
 485                git rerere clear
 486                if safe_to_abort
 487                then
 488                        git read-tree --reset -u HEAD ORIG_HEAD
 489                        git reset ORIG_HEAD
 490                fi
 491                rm -fr "$dotest"
 492                exit ;;
 493        esac
 494        rm -f "$dotest/dirtyindex"
 495else
 496        # Make sure we are not given --skip, --resolved, nor --abort
 497        test "$skip$resolved$abort" = "" ||
 498                die "$(gettext "Resolve operation not in progress, we are not resuming.")"
 499
 500        # Start afresh.
 501        mkdir -p "$dotest" || exit
 502
 503        if test -n "$prefix" && test $# != 0
 504        then
 505                first=t
 506                for arg
 507                do
 508                        test -n "$first" && {
 509                                set x
 510                                first=
 511                        }
 512                        if is_absolute_path "$arg"
 513                        then
 514                                set "$@" "$arg"
 515                        else
 516                                set "$@" "$prefix$arg"
 517                        fi
 518                done
 519                shift
 520        fi
 521
 522        check_patch_format "$@"
 523
 524        split_patches "$@"
 525
 526        # -i can and must be given when resuming; everything
 527        # else is kept
 528        echo " $git_apply_opt" >"$dotest/apply-opt"
 529        echo "$threeway" >"$dotest/threeway"
 530        echo "$sign" >"$dotest/sign"
 531        echo "$utf8" >"$dotest/utf8"
 532        echo "$keep" >"$dotest/keep"
 533        echo "$keepcr" >"$dotest/keepcr"
 534        echo "$scissors" >"$dotest/scissors"
 535        echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
 536        echo "$GIT_QUIET" >"$dotest/quiet"
 537        echo 1 >"$dotest/next"
 538        if test -n "$rebasing"
 539        then
 540                : >"$dotest/rebasing"
 541        else
 542                : >"$dotest/applying"
 543                if test -n "$HAS_HEAD"
 544                then
 545                        git update-ref ORIG_HEAD HEAD
 546                else
 547                        git update-ref -d ORIG_HEAD >/dev/null 2>&1
 548                fi
 549        fi
 550fi
 551
 552git update-index -q --refresh
 553
 554case "$resolved" in
 555'')
 556        case "$HAS_HEAD" in
 557        '')
 558                files=$(git ls-files) ;;
 559        ?*)
 560                files=$(git diff-index --cached --name-only HEAD --) ;;
 561        esac || exit
 562        if test "$files"
 563        then
 564                test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
 565                die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
 566        fi
 567esac
 568
 569if test "$(cat "$dotest/utf8")" = t
 570then
 571        utf8=-u
 572else
 573        utf8=-n
 574fi
 575if test "$(cat "$dotest/keep")" = t
 576then
 577        keep=-k
 578fi
 579case "$(cat "$dotest/keepcr")" in
 580t)
 581        keepcr=--keep-cr ;;
 582f)
 583        keepcr=--no-keep-cr ;;
 584esac
 585case "$(cat "$dotest/scissors")" in
 586t)
 587        scissors=--scissors ;;
 588f)
 589        scissors=--no-scissors ;;
 590esac
 591if test "$(cat "$dotest/no_inbody_headers")" = t
 592then
 593        no_inbody_headers=--no-inbody-headers
 594else
 595        no_inbody_headers=
 596fi
 597if test "$(cat "$dotest/quiet")" = t
 598then
 599        GIT_QUIET=t
 600fi
 601if test "$(cat "$dotest/threeway")" = t
 602then
 603        threeway=t
 604fi
 605git_apply_opt=$(cat "$dotest/apply-opt")
 606if test "$(cat "$dotest/sign")" = t
 607then
 608        SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
 609                        s/>.*/>/
 610                        s/^/Signed-off-by: /'
 611                `
 612else
 613        SIGNOFF=
 614fi
 615
 616last=`cat "$dotest/last"`
 617this=`cat "$dotest/next"`
 618if test "$skip" = t
 619then
 620        this=`expr "$this" + 1`
 621        resume=
 622fi
 623
 624while test "$this" -le "$last"
 625do
 626        msgnum=`printf "%0${prec}d" $this`
 627        next=`expr "$this" + 1`
 628        test -f "$dotest/$msgnum" || {
 629                resume=
 630                go_next
 631                continue
 632        }
 633
 634        # If we are not resuming, parse and extract the patch information
 635        # into separate files:
 636        #  - info records the authorship and title
 637        #  - msg is the rest of commit log message
 638        #  - patch is the patch body.
 639        #
 640        # When we are resuming, these files are either already prepared
 641        # by the user, or the user can tell us to do so by --resolved flag.
 642        case "$resume" in
 643        '')
 644                git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
 645                        <"$dotest/$msgnum" >"$dotest/info" ||
 646                        stop_here $this
 647
 648                # skip pine's internal folder data
 649                sane_grep '^Author: Mail System Internal Data$' \
 650                        <"$dotest"/info >/dev/null &&
 651                        go_next && continue
 652
 653                test -s "$dotest/patch" || {
 654                        eval_gettextln "Patch is empty.  Was it split wrong?
 655If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 656To restore the original branch and stop patching run \"\$cmdline --abort\"."
 657                        stop_here $this
 658                }
 659                rm -f "$dotest/original-commit" "$dotest/author-script"
 660                if test -f "$dotest/rebasing" &&
 661                        commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
 662                                -e q "$dotest/$msgnum") &&
 663                        test "$(git cat-file -t "$commit")" = commit
 664                then
 665                        git cat-file commit "$commit" |
 666                        sed -e '1,/^$/d' >"$dotest/msg-clean"
 667                        echo "$commit" > "$dotest/original-commit"
 668                        get_author_ident_from_commit "$commit" > "$dotest/author-script"
 669                else
 670                        {
 671                                sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
 672                                echo
 673                                cat "$dotest/msg"
 674                        } |
 675                        git stripspace > "$dotest/msg-clean"
 676                fi
 677                ;;
 678        esac
 679
 680        if test -f "$dotest/author-script"
 681        then
 682                eval $(cat "$dotest/author-script")
 683        else
 684                GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 685                GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 686                GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 687        fi
 688
 689        if test -z "$GIT_AUTHOR_EMAIL"
 690        then
 691                gettextln "Patch does not have a valid e-mail address."
 692                stop_here $this
 693        fi
 694
 695        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 696
 697        case "$resume" in
 698        '')
 699            if test '' != "$SIGNOFF"
 700            then
 701                LAST_SIGNED_OFF_BY=`
 702                    sed -ne '/^Signed-off-by: /p' \
 703                    "$dotest/msg-clean" |
 704                    sed -ne '$p'
 705                `
 706                ADD_SIGNOFF=`
 707                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 708                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 709                    echo "$SIGNOFF"
 710                }`
 711            else
 712                ADD_SIGNOFF=
 713            fi
 714            {
 715                if test -s "$dotest/msg-clean"
 716                then
 717                        cat "$dotest/msg-clean"
 718                fi
 719                if test '' != "$ADD_SIGNOFF"
 720                then
 721                        echo "$ADD_SIGNOFF"
 722                fi
 723            } >"$dotest/final-commit"
 724            ;;
 725        *)
 726                case "$resolved$interactive" in
 727                tt)
 728                        # This is used only for interactive view option.
 729                        git diff-index -p --cached HEAD -- >"$dotest/patch"
 730                        ;;
 731                esac
 732        esac
 733
 734        resume=
 735        if test "$interactive" = t
 736        then
 737            test -t 0 ||
 738            die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
 739            action=again
 740            while test "$action" = again
 741            do
 742                gettextln "Commit Body is:"
 743                echo "--------------------------"
 744                cat "$dotest/final-commit"
 745                echo "--------------------------"
 746                # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
 747                # in your translation. The program will only accept English
 748                # input at this point.
 749                gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 750                read reply
 751                case "$reply" in
 752                [yY]*) action=yes ;;
 753                [aA]*) action=yes interactive= ;;
 754                [nN]*) action=skip ;;
 755                [eE]*) git_editor "$dotest/final-commit"
 756                       action=again ;;
 757                [vV]*) action=again
 758                       git_pager "$dotest/patch" ;;
 759                *)     action=again ;;
 760                esac
 761            done
 762        else
 763            action=yes
 764        fi
 765
 766        if test -f "$dotest/final-commit"
 767        then
 768                FIRSTLINE=$(sed 1q "$dotest/final-commit")
 769        else
 770                FIRSTLINE=""
 771        fi
 772
 773        if test $action = skip
 774        then
 775                go_next
 776                continue
 777        fi
 778
 779        if test -x "$GIT_DIR"/hooks/applypatch-msg
 780        then
 781                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 782                stop_here $this
 783        fi
 784
 785        say "$(eval_gettext "Applying: \$FIRSTLINE")"
 786
 787        case "$resolved" in
 788        '')
 789                # When we are allowed to fall back to 3-way later, don't give
 790                # false errors during the initial attempt.
 791                squelch=
 792                if test "$threeway" = t
 793                then
 794                        squelch='>/dev/null 2>&1 '
 795                fi
 796                eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
 797                apply_status=$?
 798                ;;
 799        t)
 800                # Resolved means the user did all the hard work, and
 801                # we do not have to do any patch application.  Just
 802                # trust what the user has in the index file and the
 803                # working tree.
 804                resolved=
 805                git diff-index --quiet --cached HEAD -- && {
 806                        gettextln "No changes - did you forget to use 'git add'?
 807If there is nothing left to stage, chances are that something else
 808already introduced the same changes; you might want to skip this patch."
 809                        stop_here_user_resolve $this
 810                }
 811                unmerged=$(git ls-files -u)
 812                if test -n "$unmerged"
 813                then
 814                        gettextln "You still have unmerged paths in your index
 815did you forget to use 'git add'?"
 816                        stop_here_user_resolve $this
 817                fi
 818                apply_status=0
 819                git rerere
 820                ;;
 821        esac
 822
 823        if test $apply_status != 0 && test "$threeway" = t
 824        then
 825                if (fall_back_3way)
 826                then
 827                    # Applying the patch to an earlier tree and merging the
 828                    # result may have produced the same tree as ours.
 829                    git diff-index --quiet --cached HEAD -- && {
 830                        say "$(gettext "No changes -- Patch already applied.")"
 831                        go_next
 832                        continue
 833                    }
 834                    # clear apply_status -- we have successfully merged.
 835                    apply_status=0
 836                fi
 837        fi
 838        if test $apply_status != 0
 839        then
 840                eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
 841                stop_here_user_resolve $this
 842        fi
 843
 844        if test -x "$GIT_DIR"/hooks/pre-applypatch
 845        then
 846                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 847        fi
 848
 849        tree=$(git write-tree) &&
 850        commit=$(
 851                if test -n "$ignore_date"
 852                then
 853                        GIT_AUTHOR_DATE=
 854                fi
 855                parent=$(git rev-parse --verify -q HEAD) ||
 856                say >&2 "$(gettext "applying to an empty history")"
 857
 858                if test -n "$committer_date_is_author_date"
 859                then
 860                        GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
 861                        export GIT_COMMITTER_DATE
 862                fi &&
 863                git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
 864        ) &&
 865        git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
 866        stop_here $this
 867
 868        if test -f "$dotest/original-commit"; then
 869                echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
 870        fi
 871
 872        if test -x "$GIT_DIR"/hooks/post-applypatch
 873        then
 874                "$GIT_DIR"/hooks/post-applypatch
 875        fi
 876
 877        go_next
 878done
 879
 880if test -s "$dotest"/rewritten; then
 881    git notes copy --for-rewrite=rebase < "$dotest"/rewritten
 882    if test -x "$GIT_DIR"/hooks/post-rewrite; then
 883        "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
 884    fi
 885fi
 886
 887rm -fr "$dotest"
 888git gc --auto